#include "thing.h"
#include "spritemanager.h"
#include <framework/graphics/graphics.h>

Thing::Thing(ThingType type) : m_id(0), m_type(type)
{
}

void Thing::internalDraw(int x, int y, int blendframes, int xdiv, int ydiv, int zdiv, int anim, SpriteMask mask)
{
    const ThingAttributes& attributes = getAttributes();

    for(int yi = 0; yi < attributes.height; yi++) {
        for(int xi = 0; xi < attributes.width; xi++) {
            int sprIndex = xi +
                    yi * attributes.width +
                    blendframes * attributes.width * attributes.height +
                    xdiv * attributes.width * attributes.height * attributes.blendframes +
                    ydiv * attributes.width * attributes.height * attributes.blendframes * attributes.xdiv +
                    zdiv * attributes.width * attributes.height * attributes.blendframes * attributes.xdiv * attributes.ydiv +
                    anim * attributes.width * attributes.height * attributes.blendframes * attributes.xdiv * attributes.ydiv * attributes.zdiv;

            int spriteId = attributes.sprites[sprIndex];
            if(!spriteId)
                continue;

            TexturePtr spriteTex;
            if(mask == SpriteMaskNone) {
                spriteTex = g_sprites.getSpriteTexture(spriteId);
                g_graphics.bindColor(Color::white);
            } else
                spriteTex = g_sprites.getSpriteMask(spriteId, mask);

            Rect drawRect((x - xi*32) - attributes.xOffset,
                          (y - yi*32) - attributes.xOffset,
                          32, 32);
            g_graphics.drawTexturedRect(drawRect, spriteTex);
        }
    }
}
